struct CharTemplate
{
	char ident[4];
	int TemplateType;
	int AttributeType;
	int MinLevel;
	int MaxLevel;
	int* Class;
	int ClassCount;
	int* AttributePreset;
	int Monster;
	int MonsterName;
	int Mixed;
	int Treasure;
	int TreasureMin;
	int TreasureMax;
	int Race;
	int DrawType;
	int Life;
	struct seedstru
	{
		unsigned long seed[512];
	} seed;
	struct restru
	{
		unsigned long retemp[ReproduceSave];
		unsigned long repos;
	} re;
};

struct clsMonster
{
	string Name;
	int CR;
	int Type;
	int Size;
	int Epic;
	int HD;
	int HDType;
	int TPBonus;
	int RWRef;
	int RWWil;
	int RWZaeh;
	int Attr[6];
	int AC;
	int HDMin;
	int HDMax;
	int HDInc;
	int HDInc2;
	int Init;
	int Speed;
	int OrgMin;
	int OrgMax;
	int Mixed;
	int Treasure;
	int AttackBonus[6];
	int AttackNumber[6];
	int AttackRed[6];
	int DamageA[6];
	int DamageB[6];
	int DamageC[6];
	string AttackType[6];
	int AlternateAttack[6];
	int AttackCount;
	int Feats[6];
	int FeatCount;
	int Skills[7];
	int SkillLevels[7];
	int SkillCount;
	char* SpellChar;
	int ClericSpells;
};

struct clsPower
{
	string Name;
	int Psion;
	int PsychicW;
	int Attribute;
};

struct clsEffect
{
	string Name;
	int Weapon;
	int Armor;
	int Shield;
	int Helmet;
	int Gloves;
	int Boots;
	int Belt;
	int Cloak;
	int Ring;
	int Amulet;
	int Fight;
	int Magic;
	int Shadow;
	int Multi;
	int Cost;
	int Cost2;
	int Quality;
	char* Script;
	string SkillBoost;
	char* Variable;
};

struct clsSpell
{
	string Name;
	int Probability;
	int* ClassLevels;
	int DomainCount;
	int DomainLevel;
	int Domains[2];
	int School;
};

struct clsEquipSource
{
	string Name;
	int EquipType;
	int Damage1;
	int Damage2;
	int Damage3;
	int Size;
	int Type;
	int Critical;
	int CriticalMultiplier;
	int CriticalMultiplier2;
	int AttackType;
	int* Probability;
	int* RaceProbability;
	int StdProb;
	int Armor;
	int MaxDex;
	int Malus;
	int SpellFailure;
	int Metallic;
	int SpecialType;
	int MinLevel;
	int Rare;
	int Price;
	char* Script;
	int ForbidEffects;
};

struct clsEquip
{
	int ID;
	int EquipType;
	int Enhencement;
	int Effect[MaxEffects];
	int EffectVariable[MaxEffects];
	string EffectDesc[MaxEffects];
	int EffectCount;
	int EffectCountA;
	int Damage1;
	int Damage2;
	int Damage3;
	int Size;
	int Type;
	int Critical;
	int CriticalMultiplier;
	int CriticalMultiplier2;
	int AttackType;
	int Armor;
	int MaxDex;
	int Malus;
	int SpellFailure;
	int Metallic;
	int AttackBonus;
	int AttackBonusA;
	int TwoWeapon;
	int TwoWeaponSecond;
	int TwoHand;
	int MaxStr;
	int Primary;
	int Secondary;
	int Value;
	int Adamantine;
	int Mithril;
	int Mercury;
	int ShieldUsed;
	int IncludeInTreasure;
	int MaxEnh;
	string EquipDesc;
};



struct clsRace
{
	string Name;
	int Probability;
	int Size;
	int PreferedAttackType;
	char* Script;
	string RaceMod;
	int Range;
};

struct clsChar
{
	CharTemplate* CreationTemplate;
	clsEquip Equipment[MaxEquip];
	string MAttackType[6];

	int MonsterTWType;
	int MonsterSize;
	int HG;
	int Attributes[6];
	int Mods[6];
	int ClassCount;
	int Classes[MaxClasses];
	int DummyClass[MaxClasses];
	int DummyClassClericSpells[MaxClasses];
	int Level;
	int Levels[MaxClasses];
	int LevelsClassic[MaxClasses];
	int Life;
	int LifeBonus;
	int GA;
	int GASize;
	int GAMelee;
	int GAShot;
	int GAMeleeAttr;
	int GAShotAttr;
	int GAMeleeRest;
	int GAShotRest;
	int GAEpic;
	int RWEpic;
	int RWRef;
	int RWWil;
	int RWZaeh;
	int RWRefBase;
	int RWWilBase;
	int RWZaehBase;
	int RWRefAttr;
	int RWWilAttr;
	int RWZaehAttr;
	int RWRefMage;
	int RWWilMage;
	int RWZaehMage;
	int RWRefRest;
	int RWWilRest;
	int RWZaehRest;
	int FeatCount;
	int Feats[MaxFeats];
	int FeatDependancy[MaxFeats];
	int FeatDone[MaxFeats];
	int AttackType[2];
	int AttackTypeCount;
	int EquipCount;
	int EquipTreasureCount;
	int Skills[MaxSkills];
	int SkillLevels[MaxSkills];
	int SkillLevels2[MaxSkills];
	int SkillCount;
	int SkillCountReal;
	int SkillPoints;
	int Race;
	int SkillRequired[MaxSkills];
	int SpellsKnownCount[MaxClasses][10];
	int SpellList[MaxClasses][10][10];
	int SpellsPerDayCount[MaxClasses][10];
	int SpellListCount[MaxClasses][10];
	int Domains[2];
	int DomainSpells[10];
	int DomainSpellCount;
	int Specialised;
	int School;
	int SchoolForbidden[9];
	char CharText[BufferLen];
	char CharTextPrimary[BufferLen];
	char CharTextSecondary[BufferLen];
	char CharTextTwo[BufferLen];
	int WeaponArmorShieldFeats;
	int AC;
	int ACArmor;
	int ACShield;
	int ACDex;
	int ACSize;
	int ACRest;
	float Range;
	int MR;
	int MRBonus;
	int againstMR;
	int PR;
	int againstPR;
	int Attacks;
	int Attacks2;
	int AttacksOpportunity;
	int MonkAttacks;
	int SpecialAbbilities;
	int Lores;
	int Initiative;
	int InitiativeRest;
	int InitiativeDex;
	int ArmorMalus;
	int MaxDex;
	int RingMax;
	int BonusSpells;
	int BonusSpellLevelMin;
	int BonusSpellLevelMax;
	int AttackMod;
	int DmgMod;
	int Money;
	int MoneyRest;
	int MoneyHalf;
	int Treasure;
	int TreasureLeft;
	int UnarmedDamage1;
	int UnarmedDamage2;
	int PowerPoints;
	int MainDisciple;
	int CrystalCount;
	int CombatModes;
	int dart;
	int Monster;
	int MonsterName;
	int MonsterType;
	int MAttackBonus[6];
	int MAttackNumber[6];
	int MAttackRed[6];
	int MDamageA[6];
	int MDamageB[6];
	int MDamageC[6];
	int MAlternateAttack[6];
	int MAttackCount;
	int MSize;
	int HighestSpell;
	int CRPosCount;
	int CRPosHD[32];
	int CRPosTemplate[32];
	int CRPosCR[32];
	int SpellFailure;
	int Profiled;
	int ProfileStrength;
	int Profile;
	int Mixed;
	int MixedHG;
	int SneakDmg;
	int Evasion;
	int DestroyUndead;
	int Smite;
	int Dex2AC;
	int UncannyDodge;
	int LowLightVision;
	int DarkVision;
	int Rel;
	int InbornLeft;
	int CreationTime;
	int DisplayTime;
	int HasTemplate;
	int TouchReach;
	int TargetClass;
	int BonusFeatCount;
	int BonusSkillPointCount;
	int Arcanas;
};

struct clsCharSource
{
	int Count;
	string Name;
	int TW;
	int AttributePriority[6];
	int Probability;
	int GA;
	int RWRef;
	int RWWil;
	int RWZaeh;
	int PreferedAttack;
	int ForceAttack;
	int Skills;
	int Prestige;
	int MaxLevel;
	int MaxLevelA;
	char* Script;
	char* ClassFeats;
	int SpellType;
	int IncreaseSpellType;
	int SpontanCast;
	int SpontanCast2;
	int Domains;
	int Specialize;
	int PowerType;
	string ReqStr;
	string SkillStr;
	string FeatStr;
	string BonusFeatType;
	string BonusFeats;
	int EpicFeats;
	int SpellFailure;
	int UseEffects;
	string AttachClass;
	int NoEq;
	int PsionicDisciple;
	int PsiCrystal;
	int ForceWeaponType;
	int NaturalEnhence;
	string Derrive;
};

struct clsFeatSource
{
	string Name;
	int* Probability;
	int MultipleTimes;
	int Epic;
	string ReqStr;
	string SkillStr;
	int DepType;
	char* Script;
	int AttackDep;
	int FeatType;
	string Text;
	int Inborn;
	int* Rel;
	int RelCount;
	int Standard;
};

struct clsSkills
{
	string Name;
	int* Prob;
	int Attr;
	string Synergy;
};

struct clsDomainSource
{
	string Name;
};

struct clsMonsterTypeSource
{
	string Name;
	int GAType;
	int RWRefType;
	int RWWilType;
	int RWZaehType;
	int Mixed;
	int MixedEq;
};

struct clsRegionSource
{
	string Name;
};

struct clsSchoolSource
{
	string Name;
};

struct clsSizeSource
{
	string Name;
	int Mods[3];
	int AC;
	int SizeMod;
};

struct clsSpecialSource
{
	string Name;
	int Type;
	int SpellLevel;
	char* Script;
};

struct clsTemplateSource
{
	string Name;
	char* CRScript;
	int Mixed;
	string ForceType;
	string ForbitType;
	char* Script;
	int AttributeMod[6];
	string NewType;
};

class clsMonsterDescSource
{
public:
	string FileName;
	string Content;
	clsMonsterDescSource* NextElem;

	clsMonsterDescSource()
	{
		NextElem = NULL;
	}

	~clsMonsterDescSource()
	{
		if (NextElem)
		{
			delete NextElem;
		}
	}
};

struct ProfileFeatStruct
{
	int Feat;
};

struct ProfileClassStruct
{
	int Class;
	int Level;
};

struct ProfileWeaponStruct
{
	int Weapon;
};

struct ProfileSkillStruct
{
	int Skill;
	int MinLvl;
	int MaxLvl;
};

struct ProfileSpellStruct
{
	int Spell;
	int MaxNum;
};

struct ProfileEffectStruct
{
	int Effect;
};

struct ProfileStruct
{
	char ProfileName[256];
	
	ProfileClassStruct Classes[32];
	int ClassCount;

	ProfileWeaponStruct Weapons[32];
	int WeaponCount;
	
	ProfileFeatStruct Feats[64];
	int FeatCount;

	ProfileSkillStruct Skills[64];
	int SkillCount;
	
	ProfileSpellStruct Spells[256];
	int SpellCount;

	ProfileEffectStruct Effects[256];
	int EffectCount;

	int Armor;
	int Shield;
	int ArmorType;
	int ShieldUse[2];

	int AttackType[2];

	int Race;
	int PreferedSchool;

	int AttributePriority[6];

	int MinLevel;
};

struct clsSource
{
	clsCharSource*	CharSource;
	int CharSourceCount;
	clsFeatSource* FeatSource;
	int FeatSourceCount;
	clsEquipSource* EquipSource;
	int EquipSourceCount;
	clsSkills* SkillSource;
	int SkillSourceCount;
	clsRace* RaceSource;
	int RaceSourceCount;
	clsSpell* SpellSource;
	int SpellSourceCount;
	clsPower* PowerSource;
	int PowerSourceCount;
	clsEffect* EffectSource;
	int EffectSourceCount;
	clsMonster* MonsterSource;
	int MonsterSourceCount;
	int* MonsterCR;

	ProfileStruct* Profiles;
	int ProfileCount;

	clsMonsterDescSource* MonsterDesc;

	clsSchoolSource* SchoolSource;
	int SchoolSourceCount;
	clsSizeSource* SizeSource;
	int SizeSourceCount;
	clsMonsterTypeSource* MonsterTypeSource;
	int MonsterTypeSourceCount;
	clsDomainSource* DomainSource;
	int DomainSourceCount;
	clsTemplateSource* TemplateSource;
	int TemplateSourceCount;
	clsRegionSource* RegionSource;
	int RegionSourceCount;
	clsSpecialSource* SpecialSource;
	int SpecialSourceCount;

	string AttributeNames[6];

	int StartMoney[100];
	int Treasure[100];

	char* lpSymbolStart;
};

extern "C" clsSource Source;
