inline int AppendText(unsigned char* script, int NewLine)
{
	int i;

	int progress;
	int ArgOld;
	if (DebugOutput) {printf(" Appending Text:");}

	ArgOld = ArgCount;
	progress = ParseScript(script, 1);

	for (i = ArgOld;i < ArgCount;i++)
	{
		if (Args[i].type == 0)
		{
			sprintf(tempout, "%d", Args[i].val);
			strcat(pCurText, tempout);
		}
		else if (Args[i].type == 1)
		{
			LockString((unsigned char*) Args[i].val);
			strcat(pCurText, (char*) (Args[i].val + 1));
			ReleaseString((unsigned char*) Args[i].val);
		}
	}

	if (NewLine)
	{
		strcat(pCurText, "\n");
	}

	ArgCount = ArgOld;
	return(progress);
}

int AppendText_a(unsigned char* script)
{
	return(AppendText(script, 0));
}

int AppendText_b(unsigned char* script)
{
	return(AppendText(script, 1));
}

int* sAddfeatsyet = 0;

int sAddFeatD(unsigned char* script)
{
	int progress, ArgOld;
	int i;

	int* featsyet;
	if (sAddfeatsyet == 0)
	{
		featsyet = &pCurChar->FeatCount;
	}
	else
	{
		featsyet = sAddfeatsyet;
	}

	ArgOld = ArgCount;

	progress = ParseScript(script, 1);

	LockString((unsigned char*) Args[ArgOld].val);
	LockString((unsigned char*) Args[ArgOld + 1].val);

	for (i = 0;i < pCurChar->FeatCount;i++)
	{
		if (pCurChar->Feats[i] == GetFeatNumber((char*) Args[ArgOld + 1].val + 1))
		{
			AddFeat(pCurChar, (char*) Args[ArgOld].val + 1, featsyet, pCurChar->FeatDependancy[i]);
		}
	}

	ReleaseString((unsigned char*) Args[ArgOld + 1].val);
	ReleaseString((unsigned char*) Args[ArgOld].val);

	ArgCount = ArgOld;
	return(progress);
}

inline int sAddFeat(unsigned char* script, int dep = 0)
{
	int progress, ArgOld;
	int nFeat, nDep;
	int i;
	int* featsyet;

	if (sAddfeatsyet == 0)
	{
		featsyet = &pCurChar->FeatCount;
	}
	else
	{
		featsyet = sAddfeatsyet;
	}

	if (DebugOutput) {printf(" Adding feat:");}

	ArgOld = ArgCount;

	progress = ParseScript(script, 1);

	LockString((unsigned char*) Args[ArgOld].val);
	nFeat = GetFeatNumber((char*) Args[ArgOld].val + 1);
	ReleaseString((unsigned char*) Args[ArgOld].val);

	if (dep == 0)
	{
		nDep = -2;
		AddFeat(pCurChar, nFeat, featsyet, nDep);
	}
	else
	{
		for (i = ArgOld + 1;i < ArgCount;i++)
		{
			if (Args[i].type == 0)
			{
				nDep = Args[i].val;
			}
			else if (Args[i].type == 1)
			{
				LockString((unsigned char*) Args[i].val);
		
				if (Source.FeatSource[nFeat].DepType == depweapon)
				{
					nDep = GetEquipNumber((char*) Args[i].val + 1);
				}
				else if (Source.FeatSource[nFeat].DepType == depspell)
				{
					nDep = GetSpellNumber((char*) Args[i].val + 1);
				}
				else if (Source.FeatSource[nFeat].DepType == depskill)
				{
					nDep = GetSkillNumber((char*) Args[i].val + 1);
				}
				else
				{
					printf("Scripting Error\nFeat doesnt match for dependancy: %s\n", Source.FeatSource[nFeat].Name.buffer);
					quitprog();
				}
							
				ReleaseString((unsigned char*) Args[i].val);
			}
			else
			{
				printf("Scripting Error\nInvalid Argument for Feat: %s\n",  Source.FeatSource[nFeat].Name.buffer);
				quitprog();
			}

			AddFeat(pCurChar, nFeat, featsyet, nDep);
		}
	}

	ArgCount = ArgOld;
	return(progress);
}

int sAddFeat_a(unsigned char* script)
{
	return(sAddFeat(script, 1));
}

int sAddFeat_b(unsigned char* script)
{
	return(sAddFeat(script, 0));
}

int sFeatPresent(unsigned char* script)
{
	int progress, ArgOld;
	int retval;

	ArgOld = ArgCount;
	progress = ParseScript(script, 1);

	LockString((unsigned char*) Args[ArgOld].val);
	retval = FeatPresent(pCurChar, GetFeatNumber((char*) Args[ArgOld].val + 1), pCurChar->FeatCount);
	ReleaseString((unsigned char*) Args[ArgOld].val);

	ArgCount = ArgOld;
	Args[ArgCount].type = 0;
	Args[ArgCount].val = retval;
	ArgCount++;

	return(progress);
}

int sIsRace(unsigned char* script)
{
	int progress, ArgOld;
	int retval;

	ArgOld = ArgCount;
	progress = ParseScript(script, 1);

	LockString((unsigned char*) Args[ArgOld].val);
	retval = (pCurChar->Race == GetRaceNumber((char*) Args[ArgOld].val + 1));
	ReleaseString((unsigned char*) Args[ArgOld].val);

	ArgCount = ArgOld;
	Args[ArgCount].type = 0;
	Args[ArgCount].val = retval;
	ArgCount++;

	return(progress);
}

int sIsClass(unsigned char* script)
{
	int progress, ArgOld;
	int retval = 0, nClass;
	int i;

	ArgOld = ArgCount;
	progress = ParseScript(script, 1);

	LockString((unsigned char*) Args[ArgOld].val);
	nClass = GetCharNumber((char*) Args[ArgOld].val + 1);
	ReleaseString((unsigned char*) Args[ArgOld].val);

	for (i = 0;i < pCurChar->ClassCount;i++)
	{
		if (pCurChar->Classes[i] = nClass)
		{
			retval = 1;
			break;
		}
	}

	ArgCount = ArgOld;
	Args[ArgCount].type = 0;
	Args[ArgCount].val = retval;
	ArgCount++;

	return(progress);
}

void BoostSkillA(clsChar* TargetStruct, int nSkill, int nLevel)
{
	int i;
	bool SkillFound = false;

	for (i = 0;i < TargetStruct->SkillCount;i++)
	{
		if (TargetStruct->Skills[i] == nSkill)
		{
			TargetStruct->SkillLevels[i] += nLevel;
			SkillFound = true;
			break;
		}
	}

	if (!SkillFound)
	{
		TargetStruct->Skills[TargetStruct->SkillCount] = nSkill;
		TargetStruct->SkillLevels[TargetStruct->SkillCount] = nLevel;
		TargetStruct->SkillLevels2[TargetStruct->SkillCount] = 0;
		TargetStruct->SkillCount++;
	}

	TargetStruct->SkillPoints += nLevel;
}

inline int BoostSkill(unsigned char* script, int FeatDep = 0)
{
	int progress, ArgOld;

	int nSkill, nLevel;

	if (DebugOutput) {printf(" Boosting Skill:");}

	ArgOld = ArgCount;

	progress = ParseScript(script, 1);
	
	if (FeatDep)
	{
		nSkill = pCurChar->FeatDependancy[nCurFeat];
		nLevel = Args[ArgOld].val;
	}
	else
	{
		LockString((unsigned char*) Args[ArgOld].val);
		nSkill = GetSkillNumber((char*) Args[ArgOld].val + 1);
		ReleaseString((unsigned char*) Args[ArgOld].val);
		nLevel = Args[ArgOld + 1].val;
	}

	BoostSkillA(pCurChar, nSkill, nLevel);

	ArgCount = ArgOld;
	return(progress);
}

int BoostSkill_a(unsigned char* script)
{
	return(BoostSkill(script));
}

int BoostSkill_b(unsigned char* script)
{
	return(BoostSkill(script, 1));
}

int GetSkillLevel(unsigned char* script)
{
	int ArgOld, progress;
	int nSkill;
	int retval;
	int i;

	if (DebugOutput) {printf(" Catching Skill Level:");}
	ArgOld = ArgCount;

	progress = ParseScript(script, 1);
	LockString((unsigned char*) Args[ArgOld].val);
	nSkill = GetSkillNumber((char*) Args[ArgOld].val + 1);
	ReleaseString((unsigned char*) Args[ArgOld].val);

	ArgCount = ArgOld;

	retval = 0;
	for (i = 0;i < pCurChar->SkillCount;i++)
	{
		if (pCurChar->Skills[i] == nSkill)
		{
			retval = pCurChar->SkillLevels[i];
			break;
		}
	}

	Args[ArgCount].type = 0;
	Args[ArgCount].val = retval;
	ArgCount++;

	return(progress);
}

int GetArmorType(unsigned char* script)
{
	int MaxArmor = -1;
	int i;

	for (i = 0;i < pCurChar->EquipCount;i++)
	{
		if (pCurChar->Equipment[i].EquipType == EquipArmor && pCurChar->Equipment[i].Type > MaxArmor)
		{
			MaxArmor = pCurChar->Equipment[i].Type;
		}
	}

	Args[ArgCount].type = 0;
	Args[ArgCount].val = MaxArmor;
	ArgCount++;

	return(ParseScript(script, 1));
}

int sRandom(unsigned char* script)
{
	int progress, ArgOld;

	ArgOld = ArgCount;
	progress = ParseScript(script, 1);

	Args[ArgOld].val = random(Args[ArgOld].val, Args[ArgOld + 1].val, "Random by script");
	ArgCount = ArgOld + 1;

	return(progress);
}

int sEnhence(unsigned char* script)
{
	int progress, ArgOld;

	ArgOld = ArgCount;
	progress = ParseScript(script, 1);

	Args[ArgOld].val = Enhence(Args[ArgOld].val);

	return(progress);
}

int SubText(unsigned char* script)
{
	pCurText = pCurSubText;
	return(ParseScript(script, 1));
}

int MainText(unsigned char* script)
{
	pCurText = pCurMainText;
	return(ParseScript(script, 1));
}

int sGetElement(unsigned char* script)
{
	int ArgOld, progress;
	int Num;

	ArgOld = ArgCount;

	progress = ParseScript(script, 1);

	if (ArgCount == ArgOld)
	{
		Num = -1;
	}
	else
	{
		Num = Args[ArgOld].val;
	}

	Args[ArgOld].val = (int) GetElement(Num, 1);
	Args[ArgOld].type = 1;
	ArgCount = ArgOld + 1;

	return(progress);
}
